//----------------------------------------------------------------------------
// count_10.v - module
//----------------------------------------------------------------------------

module count_10
( CLK,
  RESET_N,
  EN,
  INIT,
  COUNT,
  CARRY
); 

input                                     CLK;
input                                     RESET_N;
input                                     EN;
input                                     INIT;
output    [3:0]                           COUNT;
output                                    CARRY;
reg       [3:0]                           COUNT;

always @( posedge CLK or negedge RESET_N )
   begin
     if ( RESET_N == 0 )
       COUNT <= 4'd0;
     else
       if (INIT==1'b1)
         COUNT <= 1'd0;
       else
         if (EN == 1'b1)
           if (COUNT == 4'd9)
             COUNT <=1'd0;
           else  
             COUNT <= COUNT + 1'd1;
         else
           COUNT <= COUNT ;
   end

assign CARRY = ((EN==1'b1)&&(COUNT==4'd9))?1'b1:1'b0;   

endmodule
